#pragma once

#define ADDRESS_INVALID				0xFFFFFFFF
#define ADDRESS_ANY					0xFFFFFFFE

#define ADDRESS_MCAST_ALL_SYSTEMS	0xE0000001
#define ADDRESS_MCAST_ALL_ROUTERS	0xE0000002
#define ADDRESS_MCAST_PIM_SM		0xE000000D

class CAddress
{
private:
	__uint32 address;

public:
	CAddress();
	CAddress(__uint32 address);
	CAddress(__byte b0, __byte b1, __byte b2, __byte b3);

	~CAddress() { };

	inline __uint32			Address() { return this->address; }
	inline bool				operator ==(CAddress address) const { return this->address == address.address; }
	inline bool				operator ==(__uint32 address) const { return this->address == address; }
	inline bool				operator !=(CAddress address) const { return this->address != address.address; }
	inline bool				operator !=(__uint32 address) const { return this->address != address; }
	inline bool				operator <(const CAddress address) const { return this->address < address.address; }
	inline bool				operator <(const __uint32) const { return this->address < address; }

	inline bool				IsValid() { return this->address != ADDRESS_INVALID; }
	inline bool				IsAny() { return this->address == ADDRESS_ANY; }
	
	inline bool				IsMulticast() { return (this->address >> 28) == 0xE; }
	inline bool				IsMulticastGroup() { return (this->address >> 27) == 0x1D; }
	inline static __uint32	Multicast(__uint32 group) { return 0xE8000000 | group; }
	inline __uint32			MulticastGroup() { return 0x07FFFFFF & this->address; }

	static inline CAddress	Any() { return CAddress(ADDRESS_ANY); }
};