#pragma once

#include "Caller.h"
#include "Delegate.h"
#include "IDelegate.h"

class Call
{
protected:
	Caller*	caller;

public:
	Call(Caller* caller) { this->caller = caller; }
	virtual ~Call() { }
};

class Call0 : public Call
{
private:
	IDelegate0<void>*	del;

public:
	Call0(Caller* caller, IDelegate0<void>* del) : Call(caller) { this->del = del; }
	virtual ~Call0() { }

	void	operator()();
};


template<typename P1> class Call1 : public Call
{
private:
	IDelegate1<void, P1>*	del;

public:
	Call1(Caller* caller, IDelegate1<void, P1>* del) : Call(caller) { this->del = del; }
	virtual ~Call1() { }

	void	operator()(P1 p1);
};

template<typename P1, typename P2> class Call2 : public Call
{
private:
	IDelegate2<void, P1, P2>*	del;

public:
	Call2(Caller* caller, IDelegate2<void, P1, P2>* del) : Call(caller) { this->del = del; }
	virtual ~Call2() { }

	void	operator()(P1 p1, P2 p2);
};

template<typename P1, typename P2, typename P3> class Call3 : public Call
{
private:
	IDelegate3<void, P1, P2, P3>*	del;

public:
	Call3(Caller* caller, IDelegate3<void, P1, P2, P3>* del) : Call(caller) { this->del = del; }
	virtual ~Call3() { }

	void	operator()(P1 p1, P2 p2, P3 p3);
};

template<typename P1, typename P2, typename P3, typename P4> class Call4 : public Call
{
private:
	IDelegate4<void, P1, P2, P3, P4>*	del;

public:
	Call4(Caller* caller, IDelegate4<void, P1, P2, P3, P4>* del) : Call(caller) { this->del = del; }
	virtual ~Call4() { }

	void	operator()(P1 p1, P2 p2, P3 p3, P4 p4);
};

template<typename P1, typename P2, typename P3, typename P4, typename P5> class Call5 : public Call
{
private:
	IDelegate5<void, P1, P2, P3, P4, P5>*	del;

public:
	Call5(Caller* caller, IDelegate5<void, P1, P2, P3, P4, P5>* del) : Call(caller) { this->del = del; }
	virtual ~Call5() { }

	void	operator()(P1 p1, P2 p2, P3 p3, P4 p4, P5 p5);
};

template<typename P1> void Call1<P1>::operator ()(P1 p1)
{
	(*this->caller)(new ICall1<P1>(this->del, p1));
}

template<typename P1, typename P2> void Call2<P1, P2>::operator ()(P1 p1, P2 p2)
{
	(*this->caller)(new ICall2<P1, P2>(this->del, p1, p2));
}

template<typename P1, typename P2, typename P3> void Call3<P1, P2, P3>::operator ()(P1 p1, P2 p2, P3 p3)
{
	(*this->caller)(new ICall3<P1, P2, P3>(this->del, p1, p2, p3));
}

template<typename P1, typename P2, typename P3, typename P4> void Call4<P1, P2, P3, P4>::operator ()(P1 p1, P2 p2, P3 p3, P4 p4)
{
	(*this->caller)(new ICall4<P1, P2, P3, P4>(this->del, p1, p2, p3, p4));
}

template<typename P1, typename P2, typename P3, typename P4, typename P5> void Call5<P1, P2, P3, P4, P5>::operator ()(P1 p1, P2 p2, P3 p3, P4 p4, P5 p5)
{
	(*this->caller)(new ICall5<P1, P2, P3, P4, P5>(this->del, p1, p2, p3, p4, p5));
}