#pragma once

#include "Connection.h"

class CConnectionEntry
{
public:
	enum EState
	{
		FREE = 0,
		ALLOC = 1,
		ASSIGNED = 2
	};
private:
	CConnectionEntry*	next;
	CConnectionEntry*	prev;
	CConnection*		connection;
	__uint32			entry;
	EState				state;

public:
	CConnectionEntry();
	~CConnectionEntry() { }

	void						Free();
	void						Alloc();
	void						Assign(CConnection* connection);

	inline CConnection*			Connection() { return this->connection; }
	inline EState				State() { return this->state; }

	inline CConnectionEntry*	Next() { return this->next; }
	inline void					Next(CConnectionEntry* next) { this->next = next; }
	inline CConnectionEntry*	Prev() { return this->prev; }
	inline void					Prev(CConnectionEntry* prev) { this->prev = prev; }
	inline __uint32				Entry() { return this->entry; }
	inline void					Entry(__uint32 entry) { this->entry = entry; }
};
