#include "Headers.h"
#include "Data.h"

#pragma warning(disable : 4996)

#define DATA_SIZE	1000000

CData::CData(
	char*		name,
	__uint32	topology,
	__uint32	numChannelsMcast
	)
{
	// Parameters
	this->numChannelsMcast = numChannelsMcast;

	// File name
	char fileName[256];

	// Data session
	sprintf(fileName, "sessions_%s_%u_%u.out", name, topology, numChannelsMcast);
	this->dataSession = new CDataSession(DATA_SIZE, fileName);
}

CData::~CData()
{
	// Data session
	delete this->dataSession;
}

void CData::Session(
	__uint32	host,
	__uint32	channel,
	__time		duration,
	__time		timeClientStart,
	__time		timeRecvStart,
	__time		timePlayStart,
	__time		timeClientFinish,
	__time		delayWait,
	__time		delaySync,
	__uint32	framesRecv,
	__uint32	framesPlay,
	__uint32*	framesSuccess,
	__uint32*	framesFail
	)
{
	// Record session
	this->dataSession->Add()->Set(
		host,
		channel,
		(channel < this->numChannelsMcast),
		(timePlayStart != -1),
		timeClientStart,
		timeRecvStart,
		timePlayStart,
		timeClientFinish,
		delayWait,
		delaySync,
		framesRecv,
		framesPlay,
		framesSuccess[0],
		framesSuccess[1],
		framesSuccess[2],
		framesFail[0],
		framesFail[1],
		framesFail[2]);


	////// Calculate the session quality
	////double quality = ((streamClientPlayFrames != 0) ? ((double)(
	////	streamClientSuccessFrames[0] +
	////	streamClientSuccessFrames[1] +
	////	streamClientSuccessFrames[2] ) /
	////	(double)streamClientPlayFrames) : 0);

	////// Global average : normal
	////this->qualityGlobalNormalSum += quality;
	////this->qualityGlobalNormalNum ++;

	////// Global average : weighted
	////this->qualityGlobalWeightedSum += (quality * sessionDuration);
	////this->qualityGlobalWeightedNum += sessionDuration;

	////// Channel average : normal
	////assert(channel < this->numChannels);
	////this->qualityChannelNormalSum[channel] += quality;
	////this->qualityChannelNormalNum[channel] ++;

	////// Channel average : weighted
	////assert(channel < this->numChannels);
	////this->qualityChannelWeightedSum[channel] += (quality * sessionDuration);
	////this->qualityChannelWeightedNum[channel] += sessionDuration;

	////// Session average
	////if((__uint32)sessionDuration < this->maxDuration)
	////{
	////	this->qualitySessionSum[(__uint32)sessionDuration] += quality;
	////	this->qualitySessionNum[(__uint32)sessionDuration]++;
	////}

	////if(streamClientTimePlayStart >= streamClientTimeClientStart)
	////{
	////	// Channel change time
	////	this->timeChannelSetupSum += (streamClientTimePlayStart - streamClientTimeClientStart);
	////	this->timeChannelSetupNum++;

	////	// Channel wait time
	////	this->timeChannelWaitSum += streamClientTimeWait;
	////	this->timeChannelWaitNum += (streamClientTimeFinish - streamClientTimePlayStart);
	////}

	////// Synchronization delay
	////if(streamClientSyncDelay >= 0)
	////{
	////	this->delaySyncNormalSum += streamClientSyncDelay;
	////	this->delaySyncNormalNum ++;

	////	this->delaySyncWeightedSum += streamClientSyncDelay * sessionDuration;
	////	this->delaySyncWeightedNum += sessionDuration;
	////}

	////// Synchronization delay distribution
	////this->delaySyncDistGlobal->Add(streamClientSyncDelay);

	////// Multicast channel statistics
	////if(channel < this->numChannelsMcast)
	////{
	////	// If the session started
	////	if(streamClientTimePlayStart >= streamClientTimeClientStart)
	////	{
	////		// Global average multicast : normal
	////		this->qualityGlobalNormalMcastSum += quality;
	////		this->qualityGlobalNormalMcastNum += 1;

	////		// Global average multicast : weighted
	////		this->qualityGlobalWeightedMcastSum += (quality * sessionDuration);
	////		this->qualityGlobalWeightedMcastNum += sessionDuration;

	////		// Channel setup time multicast
	////		this->timeChannelSetupMcastSum += (streamClientTimePlayStart - streamClientTimeClientStart);
	////		this->timeChannelSetupMcastNum++;

	////		// Channel wait time multicast
	////		this->timeChannelWaitMcastSum += streamClientTimeWait;
	////		this->timeChannelWaitMcastNum += (streamClientTimeFinish - streamClientTimePlayStart);

	////		// Synchronization delay
	////		if(streamClientSyncDelay >= 0)
	////		{
	////			this->delaySyncMcastNormalSum += streamClientSyncDelay;
	////			this->delaySyncMcastNormalNum ++;

	////			this->delaySyncMcastWeightedSum += streamClientSyncDelay * sessionDuration;
	////			this->delaySyncMcastWeightedNum += sessionDuration;
	////		}

	////		// Synchronization delay distribution
	////		this->delaySyncDistMcast->Add(streamClientSyncDelay);
	////	}
	////}
	////else
	////// Unicast channel statistics
	////{
	////	if(streamClientTimePlayStart >= streamClientTimeClientStart)
	////	{
	////		// Global average unicast : normal
	////		this->qualityGlobalNormalUcastSum += quality;
	////		this->qualityGlobalNormalUcastNum += 1;

	////		// Global average unicast : weighted
	////		this->qualityGlobalWeightedUcastSum += (quality * sessionDuration);
	////		this->qualityGlobalWeightedUcastNum += sessionDuration;

	////		// Channel setup time unicast
	////		this->timeChannelSetupUcastSum += (streamClientTimePlayStart - streamClientTimeClientStart);
	////		this->timeChannelSetupUcastNum++;

	////		// Channel wait time unicast
	////		this->timeChannelWaitUcastSum += streamClientTimeWait;
	////		this->timeChannelWaitUcastNum += (streamClientTimeFinish - streamClientTimePlayStart);

	////		// Synchronization delay
	////		if(streamClientSyncDelay >= 0)
	////		{
	////			this->delaySyncUcastNormalSum += streamClientSyncDelay;
	////			this->delaySyncUcastNormalNum ++;

	////			this->delaySyncUcastWeightedSum += streamClientSyncDelay * sessionDuration;
	////			this->delaySyncUcastWeightedNum += sessionDuration;
	////		}

	////		// Synchronization delay distribution
	////		this->delaySyncDistUcast->Add(streamClientSyncDelay);
	////	}
	////}
}
