#pragma once

#include "DataSession.h"

class CData
{
private:
	CDataSession*	dataSession;

	// Parameters
	__uint32		numChannelsMcast;


	//// Parameters
	//__time		delaySyncDistMin;
	//__time		delaySyncDistMax;
	//__uint32	delaySyncDistPoints;

	//// Quality statistics
	//__uint32	numChannels;
	//__uint32	numChannelsMcast;
	//__uint32	maxDuration;

	//double		qualityGlobalNormalSum;
	//__uint32	qualityGlobalNormalNum;
	//double		qualityGlobalWeightedSum;
	//__time		qualityGlobalWeightedNum;

	//double		qualityGlobalNormalUcastSum;
	//__uint32	qualityGlobalNormalUcastNum;
	//double		qualityGlobalWeightedUcastSum;
	//__time		qualityGlobalWeightedUcastNum;

	//double		qualityGlobalNormalMcastSum;
	//__uint32	qualityGlobalNormalMcastNum;
	//double		qualityGlobalWeightedMcastSum;
	//__time		qualityGlobalWeightedMcastNum;

	//double*		qualityChannelNormalSum;
	//__uint32*	qualityChannelNormalNum;
	//double*		qualityChannelWeightedSum;
	//__time*		qualityChannelWeightedNum;

	//double*		qualitySessionSum;
	//__uint32*	qualitySessionNum;

	//double		timeChannelSetupSum;
	//__uint32	timeChannelSetupNum;

	//double		timeChannelSetupUcastSum;
	//__uint32	timeChannelSetupUcastNum;

	//double		timeChannelSetupMcastSum;
	//__uint32	timeChannelSetupMcastNum;

	//double		timeChannelWaitSum;
	//__time		timeChannelWaitNum;

	//double		timeChannelWaitUcastSum;
	//__time		timeChannelWaitUcastNum;

	//double		timeChannelWaitMcastSum;
	//__time		timeChannelWaitMcastNum;

	//double		delaySyncNormalSum;
	//__uint32	delaySyncNormalNum;

	//double		delaySyncWeightedSum;
	//__time		delaySyncWeightedNum;

	//double		delaySyncMcastNormalSum;
	//__uint32	delaySyncMcastNormalNum;

	//double		delaySyncMcastWeightedSum;
	//__time		delaySyncMcastWeightedNum;

	//double		delaySyncUcastNormalSum;
	//__uint32	delaySyncUcastNormalNum;

	//double		delaySyncUcastWeightedSum;
	//__time		delaySyncUcastWeightedNum;

	//CDataPool*	delaySyncDistGlobal;
	//CDataPool*	delaySyncDistMcast;
	//CDataPool*	delaySyncDistUcast;

public:
	CData(
		char*		name,
		__uint32	topology,
		__uint32	numChannelsMcast
		);
	~CData();

	void			Session(
		__uint32	host,
		__uint32	channel,
		__time		duration,
		__time		timeClientStart,
		__time		timeRecvStart,
		__time		timePlayStart,
		__time		timeClientFinish,
		__time		delayWait,
		__time		delaySync,
		__uint32	framesRecv,
		__uint32	framesPlay,
		__uint32*	framesSuccess,
		__uint32*	framesFail
		);

	//inline double	QualityGlobalNormal() { return ((this->qualityGlobalNormalNum > 0) ? this->qualityGlobalNormalSum/this->qualityGlobalNormalNum : 0); }
	//inline double	QualityGlobalWeighted() { return ((this->qualityGlobalWeightedNum > 0) ? this->qualityGlobalWeightedSum/this->qualityGlobalWeightedNum : 0); }

	//inline double	QualityGlobalNormalUcast() { return ((this->qualityGlobalNormalUcastNum > 0) ? this->qualityGlobalNormalUcastSum/this->qualityGlobalNormalUcastNum : 0); }
	//inline double	QualityGlobalWeightedUcast() { return ((this->qualityGlobalWeightedUcastNum > 0) ? this->qualityGlobalWeightedUcastSum/this->qualityGlobalWeightedUcastNum : 0); }

	//inline double	QualityGlobalNormalMcast() { return ((this->qualityGlobalNormalMcastNum > 0) ? this->qualityGlobalNormalMcastSum/this->qualityGlobalNormalMcastNum : 0); }
	//inline double	QualityGlobalWeightedMcast() { return ((this->qualityGlobalWeightedMcastNum > 0) ? this->qualityGlobalWeightedMcastSum/this->qualityGlobalWeightedMcastNum : 0); }

	//inline double	QualityChannelNormal(__uint32 channel) { assert(channel < this->numChannels); return ((this->qualityChannelNormalNum[channel] > 0) ? this->qualityChannelNormalSum[channel]/this->qualityChannelNormalNum[channel] : 0); }
	//inline double	QualityChannelWeighted(__uint32 channel) { assert(channel < this->numChannels); return ((this->qualityChannelWeightedNum[channel] > 0) ? this->qualityChannelWeightedSum[channel]/this->qualityChannelWeightedNum[channel] : 0); }

	//inline double	QualitySession(__uint32 duration) { assert(duration < this->maxDuration); return ((this->qualitySessionNum[duration] > 0) ? this->qualitySessionSum[duration]/this->qualitySessionNum[duration] : 0); }

	//inline double	TimeChannelSetup() { return (this->timeChannelSetupNum > 0) ? this->timeChannelSetupSum/this->timeChannelSetupNum : 0; }
	//inline double	TimeChannelSetupUcast() { return (this->timeChannelSetupUcastNum > 0) ? this->timeChannelSetupUcastSum/this->timeChannelSetupUcastNum : 0; }
	//inline double	TimeChannelSetupMcast() { return (this->timeChannelSetupMcastNum > 0) ? this->timeChannelSetupMcastSum/this->timeChannelSetupMcastNum : 0; }

	//inline double	TimeChannelWait() { return (this->timeChannelWaitNum > 0) ? this->timeChannelWaitSum/this->timeChannelWaitNum : 0; }
	//inline double	TimeChannelWaitUcast() { return (this->timeChannelWaitUcastNum > 0) ? this->timeChannelWaitUcastSum/this->timeChannelWaitUcastNum : 0; }
	//inline double	TimeChannelWaitMcast() { return (this->timeChannelWaitMcastNum > 0) ? this->timeChannelWaitMcastSum/this->timeChannelWaitMcastNum : 0; }

	//inline double	DelaySyncNormal() { return (this->delaySyncNormalNum > 0) ? this->delaySyncNormalSum/this->delaySyncNormalNum : 0; }
	//inline double	DelaySyncWeighted() { return (this->delaySyncWeightedNum > 0) ? this->delaySyncWeightedSum/this->delaySyncWeightedNum : 0; }

	//inline double	DelaySyncMcastNormal() { return (this->delaySyncMcastNormalNum > 0) ? this->delaySyncMcastNormalSum/this->delaySyncMcastNormalNum : 0; }
	//inline double	DelaySyncMcastWeighted() { return (this->delaySyncMcastWeightedNum > 0) ? this->delaySyncMcastWeightedSum/this->delaySyncMcastWeightedNum : 0; }

	//inline double	DelaySyncUcastNormal() { return (this->delaySyncUcastNormalNum > 0) ? this->delaySyncUcastNormalSum/this->delaySyncUcastNormalNum : 0; }
	//inline double	DelaySyncUcastWeighted() { return (this->delaySyncUcastWeightedNum > 0) ? this->delaySyncUcastWeightedSum/this->delaySyncUcastWeightedNum : 0; }
};
