#include "Headers.h"
#include "DataSession.h"

CDataSession::CDataSession(
	__uint32	size,
	char*		fileName
	)
{
	// Open the file
	if(FILE_OPEN(this->file, fileName, "w"))
	{
		printf("\nCannot write to file %s.", fileName);
		this->file = NULL;
	}

	// Create the pool
	this->size = size;
	this->index = 0;
	this->count = 0;
	
	this->pool = new CDataSessionRecord[this->size];
	assert_mem(this->pool);
}

CDataSession::~CDataSession()
{
	// Write last data to the file
	this->Write();
	
	// Close the file
	if(this->file) fclose(this->file);

	// Delete the pool
	delete[] this->pool;
}

CDataSessionRecord* CDataSession::Add()
{
	// If the pool is full, write values to file
	if(this->index == this->size) this->Write();

	assert(this->index < this->size);

	// Add value to pool
	this->pool[this->index].Index(this->count++);
	return &this->pool[this->index++];
}

void CDataSession::Write()
{
	// Write the pool values to the file
	for(__uint32 idx = 0; idx < this->index; idx++) this->pool[idx].Write(this->file);

	// Reset the pool index
	this->index = 0;
}