#pragma once

#define _CRTDBG_MAP_ALLOC
#define _CRT_RAND_S

#ifdef _WINDOWS
#ifndef _WIN32_WINNT
#define _WIN32_WINNT 0x0600
#endif
#endif

#ifdef _WINDOWS
#include <crtdbg.h>
#endif
#include <stdlib.h>
#include <iostream>
#include <malloc.h>
#include <assert.h>
#include <stdio.h>
#ifdef _WINDOWS
#include <tchar.h>
#endif
#include <math.h>
#include <string.h>
#include <time.h>
#include <list>
#include <map>
#include <set>
#include <vector>
#include <queue>

#include "IDelegate.h"
#include "Delegate.h"
#include "Event.h"
#include "ICall.h"
#include "Call.h"
#include "Platform.h"

using namespace std;

#ifdef _LINUX
#define __int8						char
#define __int16						short
#define __int32						int
#define __int64						long long
#endif

#define __bitrate					double
#define __time						double
#define __byte						unsigned __int8
#define __bits						unsigned __int64

#define __uint8						unsigned __int8
#define __uint16					unsigned __int16
#define __uint32					unsigned __int32
#define __uint64					unsigned __int64

#ifdef _DEBUG
#define type_cast					dynamic_cast
#else
#define type_cast					static_cast
#endif

#define TIME_UNIT					((__time)1)
#define TIME_INVALID				((__time)-1)
#define RATE_UNIT					((__bitrate)1000)

#if defined(_WINDOWS) && defined(_DEBUG)
#define DEBUG_NEW					new(_NORMAL_BLOCK, __FILE__, __LINE__)
#define new							DEBUG_NEW
#endif

#ifdef _DEBUG
#define assert_mem(ptr)				{ if(NULL == ptr) { printf("\nOut of memory in file: %s line %d", __FILE__, __LINE__); exit(-1); } }
#else
#define assert_mem(ptr)				((void)0)
#endif

#define error(msg)					{ printf(msg); exit(-1); }
#define warn(msg)					{ printf(msg); }

#if defined(_RELEASEASSERT) || defined(_RELEASELOG)
#ifdef assert
#undef assert
#endif
#define assert(x)					{if(!(x)) { printf("\nError in file %s at line %u", __FILE__, __LINE__); __debugbreak(); } }
#endif

#if defined(_DEBUG) || defined(_RELEASELOG)
#define								DETRAND
#endif

#ifdef _WINDOWS
#define FILE_OPEN(file, name, mode)	fopen_s(&file, name, mode)
#else
#define FILE_OPEN(file, name, mode)	((file = fopen(name, mode)) == NULL)
#endif