#pragma once

#include "HostClient.h"
#include "StreamClientPull.h"
#include "InfoPush.h"

class CHostClientPull : public CHostClient
{
protected:
	// Global
	CInfoPull*					info;

	// Delegates
	Delegate4<CHostClientPull, void, __uint32, CPacketIp*, CPacketUdp*, CPacket*>*
								delegateRecv;	
	Delegate0<CHostClientPull, CLink*>*
								delegateLink;

public:
	CHostClientPull(
		__uint32		id,
		CSimHandler*	sim,
		CAddress		address,
		CInfoPull*		info,
		CData*			data,
		__bitrate		bw
		);
	virtual ~CHostClientPull();

	virtual void	Finalize();

protected:
	virtual void	ChannelConnectUcast(CChannel* channel);
	virtual void	ChannelDisconnectUcast();

	virtual void	ChannelConnectMcast(CChannel* channel);
	virtual void	ChannelDisconnectMcast();

private:
	void			Recv(__uint32 entry, CPacketIp* ip, CPacketUdp* udp, CPacket* packet);

	void			SendStream(CAddress dst, CPacketStream* packet);
	void			SendMessage(CAddress dst, CStreamMessage* message);

	inline CLink*	Link() { return CNode::Link(0); }
};