#pragma once

#include "HostClient.h"
#include "StreamClientPush.h"
#include "InfoPush.h"

class CHostClientPush : public CHostClient
{
protected:
	// Global
	CInfoPush*					info;

	// Delegates
	Delegate4<CHostClientPush, void, __uint32, CPacketIp*, CPacketUdp*, CPacket*>*
								delegateRecv;

	Delegate2<CHostClientPush, void, CAddress, CPacketStream*>*
								delegateSendStream;
	Delegate2<CHostClientPush, void, CAddress, CStreamMessage*>*
								delegateSendMessage;
	
	Delegate0<CHostClientPush, CLink*>*
								delegateLink;

public:
	CHostClientPush(
		__uint32		id,
		CSimHandler*	sim,
		CAddress		address,
		CInfoPush*		info,
		CData*			data,
		__bitrate		bw
		);
	virtual ~CHostClientPush();

	virtual void	Finalize();

protected:
	virtual void	ChannelConnectUcast(CChannel* channel);
	virtual void	ChannelDisconnectUcast();

	virtual void	ChannelConnectMcast(CChannel* channel);
	virtual void	ChannelDisconnectMcast();

private:
	void			Recv(__uint32 entry, CPacketIp* ip, CPacketUdp* udp, CPacket* packet);

	void			SendStream(CAddress dst, CPacketStream* packet);
	void			SendMessage(CAddress dst, CStreamMessage* message);

	inline CLink*	Link() { return CNode::Link(0); }
};