#pragma once

#include "HostClient.h"
#include "StreamClientPushMulti.h"

class CHostClientPushMulti : public CHostClient
{
protected:
	// Global
	CInfoPushMulti*				info;

	// Delegates
	Delegate4<CHostClientPushMulti, void, __uint32, CPacketIp*, CPacketUdp*, CPacket*>*
								delegateRecv;

	Delegate2<CHostClientPushMulti, void, CAddress, CPacketStream*>*
								delegateSendStream;
	Delegate2<CHostClientPushMulti, void, CAddress, CStreamMessage*>*
								delegateSendMessage;
	
	Delegate0<CHostClientPushMulti, CLink*>*
								delegateLink;

public:
	CHostClientPushMulti(
		__uint32		id,
		CSimHandler*	sim,
		CAddress		address,
		CInfoPushMulti*	info,
		CData*			data,
		__bitrate		bw
		);
	virtual ~CHostClientPushMulti();

	virtual void	Finalize();

protected:
	virtual void	ChannelConnectUcast(CChannel* channel);
	virtual void	ChannelDisconnectUcast();

	virtual void	ChannelConnectMcast(CChannel* channel);
	virtual void	ChannelDisconnectMcast();

private:
	void			Recv(__uint32 entry, CPacketIp* ip, CPacketUdp* udp, CPacket* packet);

	void			SendStream(CAddress dst, CPacketStream* packet);
	void			SendMessage(CAddress dst, CStreamMessage* message);

	inline CLink*	Link() { return CNode::Link(0); }
};