#pragma once

#include "HostServer.h"
#include "InfoPull.h"
#include "StreamServerPushMcast.h"
#include "StreamServerPull.h"

class CHostServerPull : public CHostServer
{
protected:
	CInfoPull*					info;

	// Stream servers
	CStreamServerPushMcast**	streamServersMcast;
	CStreamServerPull*			streamServerUcast;

	// Delegates
	Delegate4<CHostServerPull, void, __uint32, CPacketIp*, CPacketUdp*, CPacket*>*
		delegateRecv;

	Delegate0<CHostServerPull, CLink*>*
		delegateLink;
	
	Delegate2<CHostServerPull, void, CAddress, CPacketStream*>*
		delegateSendStream;
	Delegate2<CHostServerPull, void, CAddress, CStreamMessage*>*
		delegateSendMessage;

public:
	CHostServerPull(
		__uint32		id,
		CSimHandler*	sim,
		CAddress		address,
		CInfoPull*		info,
		CData*			data
		);
	virtual ~CHostServerPull();

	virtual void		Start();
	virtual void		Stop();
	
	virtual void		Finalize();

private:
	void				Recv(__uint32, CPacketIp* ip, CPacketUdp* udp, CPacket* packet);

	void				SendStream(CAddress dst, CPacketStream* packet);
	void				SendMessage(CAddress dst, CStreamMessage* message);

	inline CLink*		Link() { return CNode::Link(0); }
};