#pragma once

#include "HostServer.h"
#include "InfoPush.h"
#include "StreamServerPushMcast.h"
#include "StreamServerPushUcast.h"

class CHostServerPush : public CHostServer
{
protected:
	CInfoPush*					info;

	// Stream servers
	CStreamServerPushMcast**	streamServersMcast;
	CStreamServerPushUcast**	streamServersUcast;

	// Delegates
	Delegate4<CHostServerPush, void, __uint32, CPacketIp*, CPacketUdp*, CPacket*>*
		delegateRecv;
	
	Delegate2<CHostServerPush, void, CAddress, CPacketStream*>*
		delegateSendStream;
	Delegate2<CHostServerPush, void, CAddress, CStreamMessage*>*
		delegateSendMessage;

public:
	CHostServerPush(
		__uint32		id,
		CSimHandler*	sim,
		CAddress		address,
		CInfoPush*		info,
		CData*			data
		);
	virtual ~CHostServerPush();

	virtual void		Start();
	virtual void		Stop();
	
	virtual void		Finalize();

private:
	void				Recv(__uint32, CPacketIp* ip, CPacketUdp* udp, CPacket* packet);

	void				SendStream(CAddress dst, CPacketStream* packet);
	void				SendMessage(CAddress dst, CStreamMessage* message);
};