#pragma once

#include "HostServer.h"
#include "InfoPushMulti.h"
#include "Timer.h"

#include "StreamServerPushMcast.h"
#include "StreamServerPushUcastMulti.h"

class CHostServerPushMulti : public CHostServer
{
protected:
	CInfoPushMulti*					info;

	// Stream servers
	CStreamServerPushMcast**		streamServersMcast;
	CStreamServerPushUcastMulti**	streamServersUcast;

	// Delegates
	Delegate4<CHostServerPushMulti, void, __uint32, CPacketIp*, CPacketUdp*, CPacket*>*
		delegateRecv;
	
	Delegate2<CHostServerPushMulti, void, CAddress, CPacketStream*>*
		delegateSendStream;
	Delegate2<CHostServerPushMulti, void, CAddress, CStreamMessage*>*
		delegateSendMessage;

public:
	CHostServerPushMulti(
		__uint32		id,
		CSimHandler*	sim,
		CAddress		address,
		CInfoPushMulti*	info,
		CData*			data
		);
	virtual ~CHostServerPushMulti();

	virtual void		Start();
	virtual void		Stop();
	
	virtual void		Finalize();

private:
	void				Recv(__uint32, CPacketIp* ip, CPacketUdp* udp, CPacket* packet);

	void				SendStream(CAddress dst, CPacketStream* packet);
	void				SendMessage(CAddress dst, CStreamMessage* message);

};