#pragma once

#include "IDelegate.h"

class ICall
{
public:
	virtual void	operator()() = 0;
};

class ICall0 : public ICall
{
private:
	IDelegate0<void>*	del;

public:
	ICall0(IDelegate0<void>* del) { this->del = del; }
	virtual ~ICall0() { }

	inline virtual void	operator()() { (*this->del)(); }
};


template<typename P1> class ICall1 : public ICall
{
private:
	IDelegate1<void, P1>*	del;
	P1						p1;

public:
	ICall1(IDelegate1<void, P1>* del, P1 p1) { this->del = del; this->p1 = p1; }
	virtual ~ICall1() { }

	inline virtual void	operator()() { (*this->del)(p1); }
};

template<typename P1, typename P2> class ICall2 : public ICall
{
private:
	IDelegate2<void, P1, P2>*	del;
	P1							p1;
	P2							p2;

public:
	ICall2(IDelegate2<void, P1, P2>* del, P1 p1, P2 p2) { this->del = del; this->p1 = p1; this->p2 = p2; }
	virtual ~ICall2() { }

	inline virtual void	operator()() { (*this->del)(p1, p2); }
};

template<typename P1, typename P2, typename P3> class ICall3 : public ICall
{
private:
	IDelegate3<void, P1, P2, P3>*	del;
	P1								p1;
	P2								p2;
	P3								p3;

public:
	ICall3(IDelegate3<void, P1, P2, P3>* del, P1 p1, P2 p2, P3 p3) { this->del = del; this->p1 = p1; this->p2 = p2; this->p3 = p3; }
	virtual ~ICall3() { }

	inline virtual void	operator()() { (*this->del)(p1, p2, p3); }
};

template<typename P1, typename P2, typename P3, typename P4> class ICall4 : public ICall
{
private:
	IDelegate4<void, P1, P2, P3, P4>*	del;
	P1									p1;
	P2									p2;
	P3									p3;
	P4									p4;

public:
	ICall4(IDelegate4<void, P1, P2, P3, P4>* del, P1 p1, P2 p2, P3 p3, P4 p4) { this->del = del; this->p1 = p1; this->p2 = p2; this->p3 = p3; this->p4 = p4; }
	virtual ~ICall4() { }

	inline virtual void	operator()() { (*this->del)(p1, p2, p3, p4); }
};

template<typename P1, typename P2, typename P3, typename P4, typename P5> class ICall5 : public ICall
{
private:
	IDelegate5<void, P1, P2, P3, P4, P5>*	del;
	P1										p1;
	P2										p2;
	P3										p3;
	P4										p4;
	P5										p5;

public:
	ICall5(IDelegate5<void, P1, P2, P3, P4, P5>* del, P1 p1, P2 p2, P3 p3, P4 p4, P5 p5) { this->del = del; this->p1 = p1; this->p2 = p2; this->p3 = p3; this->p4 = p4; this->p5 = p5; }
	virtual ~ICall5() { }

	inline virtual void	operator()() { (*this->del)(p1, p2, p3, p4, p5); }
};