#pragma once

#include "Address.h"
#include "Channel.h"
#include "Workload.h"
#include "StreamSource.h"
#include "Codes.h"
#include "Multicast.h"

class CInfo
{
public:
	CInfo() { }
	virtual ~CInfo() { }

	virtual __uint32		NumGroups() = 0;

	virtual CChannel*		Channel(__uint32 index) = 0;
	virtual CChannel*		ChannelMulticast(__uint32 index) = 0;
	virtual CChannel*		ChannelUnicast(__uint32 index) = 0;

	virtual CWorkload*		Workload() = 0;

#ifdef MULTICAST
	virtual void			MulticastJoin(__uint32 host, __uint32 group) = 0;
	virtual void			MulticastLeave(__uint32 host, __uint32 group) = 0;
#endif
};
