#pragma once

#include "Info.h"
#include "Address.h"

#define PULL_MAX_SENDERS	10

class CInfoPull : public CInfo
{
public:
	CInfoPull() { }
	virtual ~CInfoPull() { }

	virtual __uint32		NumChannels() = 0;
	virtual __uint32		NumChannelsMulticast() = 0;
	virtual __uint32		NumChannelsUnicast() = 0;

	virtual __uint32		IndexGlobalToMulticast(__uint32 index) = 0;
	virtual __uint32		IndexGlobalToUnicast(__uint32 index) = 0;
	virtual __uint32		IndexMulticastToGlobal(__uint32 index) = 0;
	virtual __uint32		IndexUnicastToGlobal(__uint32 index) = 0;

	virtual CStreamSource*	StreamSource(__uint32 index) = 0;
	virtual __time			StreamFrameInterval() = 0;

	virtual __uint32		StreamBufferMcastSize() = 0;
	virtual __uint32		StreamBufferMcastSizeHistory() = 0;
	virtual __uint32		StreamBufferMcastSizeBuffering() = 0;
	virtual __uint32		StreamBufferUcastSize() = 0;
	virtual __uint32		StreamBufferUcastSizeHistory() = 0;
	virtual __uint32		StreamBufferUcastSizeBuffering() = 0;
	virtual __time			StreamBufferUnderrunTimeout() = 0;

	virtual __uint32		BootQueryMax() = 0;
	virtual __uint32		BootRefreshThreshold() = 0;
	virtual __time			BootQueryTimeout() = 0;
	virtual __time			BootRegisterDelay() = 0;

	virtual __uint32		NumPartners() = 0;
	virtual __uint32		ScheduleSize() = 0;
	virtual __time			ScheduleInterval() = 0;
	virtual __uint32		StreamSegmentSize() = 0;

	virtual __uint16		PortStream() = 0;
	virtual __uint16		PortControl() = 0;
	virtual __uint16		PortConnection() = 0;

	virtual __uint32		ClientConnectionsMax() = 0;
	virtual __uint32		ServerConnectionsMax() = 0;
	virtual CAddress		ServerAddress() = 0;
	virtual __uint32		ConnectionSegmentSize() = 0;
};