#pragma once

#include "Layer.h"
#include "PacketIp.h"
#include "Route.h"

class CLayerIpLocal : public CLayer
{
private:
	CAddress													address;
	CRoute*														route;

	Delegate2<CLayerIpLocal, void, __uint32, CPacketIp*>*		delegateRecv;
	Delegate2<CLayerIpLocal, void, __uint32, CPacketIp*>*		delegateRecvMcast;
	Event3<void, __uint32, CPacketIp*, CPacket*>*				eventRecv;

	Delegate3<CLayerIpLocal, void, CAddress, __byte, CPacket*>*	delegateSend;
	Event2<void, __uint32, CPacketIp*>*							eventSend;
	Event1<void, CPacketIp*>*									eventSendMcast;

public:
	CLayerIpLocal(
		CSimHandler*	sim,
		CAddress		address,
		CRoute*			route
		);
	virtual ~CLayerIpLocal();

	inline IDelegate2<void, __uint32, CPacketIp*>*
		DelegateRecv() { return this->delegateRecv; }
	inline IDelegate2<void, __uint32, CPacketIp*>*
		DelegateRecvMcast() { return this->delegateRecvMcast; }
	inline Event3<void, __uint32, CPacketIp*, CPacket*>*
		EventRecv() { return this->eventRecv; }

	inline IDelegate3<void, CAddress, __byte, CPacket*>*
		DelegateSend() { return this->delegateSend; }
	inline Event2<void, __uint32, CPacketIp*>*
		EventSend() { return this->eventSend; }
	inline Event1<void, CPacketIp*>*
		EventSendMcast() { return this->eventSendMcast; }

	virtual void	Finalize() { }

private:
	void			Recv(__uint32 entry, CPacketIp* packet);
	void			RecvMcast(__uint32 entry, CPacketIp* packet);
	void			Send(CAddress dst, __byte ttl, CPacket* payload);
};
