#pragma once

#include "Layer.h"
#include "Route.h"
#include "PacketIp.h"

class CLayerIpRoute : public CLayer
{
private:
	CAddress	address;
	CRoute*		route;

	// Delegates
	Delegate2<CLayerIpRoute, void, __uint32, CPacketIp*>*	delegateRecv;

	// Events
	Event2<void, __uint32, CPacketIp*>*						eventSend;

public:
	CLayerIpRoute(
		CSimHandler*	sim,
		CAddress		address,
		CRoute*			route
		);
	virtual ~CLayerIpRoute();

	inline IDelegate2<void, __uint32, CPacketIp*>*
		DelegateRecv() { return this->delegateRecv; }
	
	inline Event2<void, __uint32, CPacketIp*>*
		EventSend() { return this->eventSend; }

	virtual void	Finalize() { }

private:
	void	Recv(__uint32 entry, CPacketIp* packet);
};
