#include "Headers.h"
#include "LayerUdp.h"

CLayerUdp::CLayerUdp(CSimHandler* sim) : CLayer(sim)
{
	this->delegateRecv = new Delegate3<CLayerUdp, void, __uint32, CPacketIp*, CPacket*>(this, &CLayerUdp::Recv);
	assert_mem(this->delegateRecv);

	this->eventRecv = new Event4<void, __uint32, CPacketIp*, CPacketUdp*, CPacket*>();
	assert_mem(this->eventRecv);

	this->delegateSend = new Delegate5<CLayerUdp, void, __uint16, __uint16, CAddress, __byte, CPacket*>(this, &CLayerUdp::Send);
	assert_mem(this->delegateSend);

	this->eventSend = new Event3<void, CAddress, __byte, CPacket*>();
	assert_mem(this->eventSend);
}

CLayerUdp::~CLayerUdp()
{
	delete this->delegateRecv;
	delete this->eventRecv;

	delete this->delegateSend;
	delete this->eventSend;
}

void CLayerUdp::Recv(__uint32 entry, CPacketIp* ip, CPacket* packet)
{
	// Verify the packet is IP
	if(NULL == packet) return;
	if(packet->Type() != PACKET_TYPE_UDP) return;

	// Send the packet to the upper layers
	(*this->eventRecv)(entry, ip, type_cast<CPacketUdp*>(packet), packet->Payload());
}

void CLayerUdp::Send(__uint16 src, __uint16 dst, CAddress address, __byte ttl, CPacket* payload)
{
	// Create a new UDP packet
	CPacketUdp* packet = new CPacketUdp(src, dst, payload);

	// Send the packet to the lower layer
	(*this->eventSend)(address, ttl, packet);
}