#pragma once

#include "Layer.h"
#include "PacketIp.h"
#include "PacketUdp.h"

class CLayerUdp : public CLayer
{
private:
	Delegate3<CLayerUdp, void, __uint32, CPacketIp*, CPacket*>*					delegateRecv;
	Event4<void, __uint32, CPacketIp*, CPacketUdp*, CPacket*>*					eventRecv;

	Delegate5<CLayerUdp, void, __uint16, __uint16, CAddress, __byte, CPacket*>*	delegateSend;
	Event3<void, CAddress, __byte, CPacket*>*									eventSend;

public:
	CLayerUdp(CSimHandler* sim);
	virtual ~CLayerUdp();

	inline IDelegate3<void, __uint32, CPacketIp*, CPacket*>*
		DelegateRecv() { return this->delegateRecv; }
	inline Event4<void, __uint32, CPacketIp*, CPacketUdp*, CPacket*>*
		EventRecv() { return this->eventRecv; }

	inline IDelegate5<void, __uint16, __uint16, CAddress, __byte, CPacket*>*
		DelegateSend() { return this->delegateSend; }
	inline Event3<void, CAddress, __byte, CPacket*>*
		EventSend() { return this->eventSend; }

	virtual void	Finalize() { }

private:
	void			Recv(__uint32 entry, CPacketIp* ip, CPacket* packet);
	void			Send(__uint16 src, __uint16 dst, CAddress address, __byte ttl, CPacket* payload);
};