#pragma once

#include "Packet.h"

#define LINK_QUEUE_NEXT(ptr) ((ptr + 1) % this->size)

class CLinkQueue
{
protected:
	CPacket**	queue;
	__time*		time;
	__uint32	size;
	__uint32	ptr;
	__uint32	count;
	__bits		usage;

public:
	CLinkQueue(
		__uint32	size
		);
	~CLinkQueue();

	inline bool			IsEmpty() { return this->count == 0; }
	inline bool			IsFull() { return this->count == this->size; }

	inline CPacket*		First() { return this->count?this->queue[this->ptr]:NULL; }
	inline CPacket*		Last() { return this->count?this->queue[(this->ptr + this->count - 1) % this->size]:NULL; }

	inline __uint32		Size() { return this->size; }
	inline __uint32		Packets() { return this->count; }
	inline __bits		Usage() {  return this->usage; }

	inline __time		TimeFirst() { return this->time[this->ptr]; }

	void				Add(__time time, CPacket* packet);
	void				Remove();
};