#include "Headers.h"
#include "Multicast.h"

CMulticast::CMulticast(__uint32 groups, CTopo* topology, __uint32 source)
{
	this->groups = groups;

	this->trees = new CMulticastTree*[this->groups];
	assert_mem(this->trees);

	for(__uint32 index = 0; index < this->groups; index++)
	{
		this->trees[index] = new CMulticastTree(topology, index, source);
		assert_mem(this->trees[index]);
	}
}

CMulticast::~CMulticast()
{
	for(__uint32 index = 0; index < this->groups; index++)
		delete this->trees[index];
	delete[] this->trees;
}
