#pragma once

#include "Topo.h"
#include "MulticastNode.h"

class CMulticastTree
{
private:
	__uint32		source;
	__uint32		group;
	CTopo*			topology;

	CMulticastNode*	nodes;

	__uint32		sizeCoreLast;
	__time			sizeCoreTime;
	double			sizeCore;

	__uint32		sizeEdgeLast;
	__time			sizeEdgeTime;
	double			sizeEdge;

public:
	CMulticastTree(CTopo* topology, __uint32 group, __uint32 source);
	virtual ~CMulticastTree();

	void			Add(__time time, __uint32 host, __uint32 gw);
	void			Remove(__time time, __uint32 host, __uint32 gw);

	void			Clear();

	void			Finalize(__time time);

	inline double	SizeCore() { return this->sizeCore; }
	inline double	SizeEdge() { return this->sizeEdge; }

	inline __uint32	SizeCoreLast() { return this->sizeCoreLast; }
	inline __uint32	SizeEdgeLast() { return this->sizeEdgeLast; }
};