#pragma once

#include "Codes.h"

class CPacket
{
public:
	enum ETypeOfService
	{
		PACKET_TOS_HIGH = 0,
		PACKET_TOS_LOW = 1
	};

protected:
	__uint32		size;	
	CPacket*		payload;
	ETypeOfService	tos;

public:
	CPacket(
		__uint32		size,
		CPacket*		payload,
		ETypeOfService	tos = PACKET_TOS_LOW
		);
	virtual ~CPacket() { }

	inline __uint32			Size() { return this->size; }
	inline CPacket*			Payload() { return this->payload; }
	inline ETypeOfService	Tos() { return this->tos; }
	
	virtual EPacketType		Type() = 0;
	virtual CPacket*		Copy() = 0;

	void					Delete();

	virtual inline char*	ToString() { return NULL; }
};
