#pragma once

#include "Packet.h"

class CPacketConnection : public CPacket
{
public:
	enum ETypeConnection
	{
		DATA = 0,
		FEEDBACK = 1,
		MESSAGE = 2
	};

protected:
	// Packet type
	ETypeConnection	typeConnection;

	// Connections
	__uint32		src;
	__uint32		dst;
	__uint32		srcEntry;
	__uint32		dstEntry;

	// Stream
	__uint32		flow;

	// Flow
	__time			timeTx;
	__time			timeRx;
	__time			timeDelay;

public:
	CPacketConnection(
		__uint32		size,
		ETypeConnection	typeConnection,
		__uint32		flow,
		__uint32		src,
		__uint32		dst,
		__uint32		srcEntry,
		__uint32		dstEntry,
		ETypeOfService	tos,
		__time			timeTx,
		__time			timeRx = -1,
		__time			timeDelay = 0
		);
	virtual ~CPacketConnection() { }

	virtual EPacketType		Type() { return PACKET_TYPE_CONNECTION; }
	ETypeConnection			TypeConnection() { return this->typeConnection; }

	inline __uint32			Src() { return this->src; }
	inline __uint32			Dst() { return this->dst; }
	inline __uint32			SrcEntry() { return this->srcEntry; }
	inline __uint32			DstEntry() { return this->dstEntry; }
	inline __uint32			Flow() { return this->flow; }

	inline __time			TimeTx() { return this->timeTx; }
	inline __time			TimeRx() { return this->timeRx; }
	inline __time			TimeDelay() { return this->timeDelay; }
};