#include "Headers.h"
#include "PacketConnectionData.h"

CPacketConnectionData::CPacketConnectionData(
	__uint32		flow,
	__uint32		src,
	__uint32		dst,
	__uint32		srcEntry,
	__uint32		dstEntry,
	CPacket*		payload,
	__uint32		sequence,
	__time			timeTx,
	__time			rtt
	) : CPacketConnection(payload->Size() + 96, CPacketConnection::DATA, flow, src, dst, srcEntry, dstEntry, CPacket::PACKET_TOS_LOW, timeTx)
{
	this->payload = payload;
	this->sequence = sequence;
	this->rtt = rtt;
}

CPacket* CPacketConnectionData::Copy()
{
	CPacketConnectionData* packet = new CPacketConnectionData(
		this->flow,
		this->src,
		this->dst,
		this->srcEntry,
		this->dstEntry,
		this->payload->Copy(),
		this->sequence,
		this->timeTx,
		this->rtt);
	assert_mem(packet);

	return packet;
}