#include "Headers.h"
#include "PacketConnectionFeedback.h"

CPacketConnectionFeedback::CPacketConnectionFeedback(
	__uint32	flow,
	__uint32	src,
	__uint32	dst,
	__uint32	srcEntry,
	__uint32	dstEntry,
	__time		timeTx,
	__time		timeRx,
	__time		timeDelay,
	__bitrate	rateRecv,
	double		rateLoss,
	__uint64	ack,
	__uint32	ackSeq,
	__uint64	lost,
	__uint32	lostSeq
	) : CPacketConnection(32, CPacketConnection::FEEDBACK, flow, src, dst, srcEntry, dstEntry, CPacket::PACKET_TOS_HIGH, timeTx, timeRx, timeDelay)
{
	this->rateRecv = rateRecv;
	this->rateLoss = rateLoss;

	this->ack = ack;
	this->ackSeq = ackSeq;

	this->lost = lost;
	this->lostSeq = lostSeq;
}

CPacket* CPacketConnectionFeedback::Copy()
{
	CPacketConnectionFeedback* packet = new CPacketConnectionFeedback(
		this->flow,
		this->src,
		this->dst,
		this->srcEntry,
		this->dstEntry,
		this->timeTx,
		this->timeRx,
		this->timeDelay,
		this->rateRecv,
		this->rateLoss,
		this->ack,
		this->ackSeq,
		this->lost,
		this->lostSeq
		);
	assert_mem(packet);

	return packet;
}