#pragma once

#include "PacketConnection.h"

class CPacketConnectionFeedback : public CPacketConnection
{
private:
	__bitrate	rateRecv;
	double		rateLoss;
	
	// Acknowledged packets
	__uint64	ack;
	__uint32	ackSeq;

	// Lost packets
	__uint64	lost;
	__uint32	lostSeq;

public:
	CPacketConnectionFeedback(
		__uint32	flow,
		__uint32	src,
		__uint32	dst,
		__uint32	srcEntry,
		__uint32	dstEntry,
		__time		timeTx,
		__time		timeRx,
		__time		timeDelay,
		__bitrate	rateRecv,
		double		rateLoss,
		__uint64	ack = 0,
		__uint32	ackSeq = 0,
		__uint64	lost = 0,
		__uint32	lostSeq = 0
		);
	virtual ~CPacketConnectionFeedback() { }

	inline __bitrate	RateRecv() { return this->rateRecv; }
	inline double		RateLoss() { return this->rateLoss; }

	inline __uint64		Ack() { return this->ack; }
	inline __uint64		Lost() { return this->lost; }

	inline __uint32		AckSeq() { return this->ackSeq; }
	inline __uint32		LostSeq() { return this->lostSeq; }

	virtual CPacket*	Copy();
};