#pragma once

#include "PacketConnection.h"

#define PACKET_INVALID_CONNECTION		0xFFFFFFFF
#define PACKET_INVALID_CONNECTION_ENTRY	0xFFFFFFFF

class CPacketConnectionMessage : public CPacketConnection
{
public:
	enum ETypeMessage
	{
		OPEN = 0,
		OPEN_ACK = 1,
		CLOSE = 2,
		CLOSE_ACK = 3,
		CLOSE_ACK_ACK = 4
	};

private:
	// Message type
	ETypeMessage	typeMessage;

public:
	CPacketConnectionMessage(
		__uint32		flow,
		__uint32		src,
		__uint32		srcEntry,
		__time			timeTx
		);
	CPacketConnectionMessage(
		__uint32		flow,
		__uint32		src,
		__uint32		dst,
		__uint32		srcEntry,
		__uint32		dstEntry,
		ETypeMessage	type,
		__time			timeTx,
		__time			timeRx = -1
		);
	virtual ~CPacketConnectionMessage() { }

	inline ETypeMessage	TypeMessage() { return this->typeMessage; }

	virtual CPacket*	Copy();
};