#pragma once

#include "Packet.h"
#include "Address.h"

#define PACKET_IGMP_HEADER	64

class CPacketIgmp : public CPacket
{
public:
	enum EPacketIgmpType
	{
		PACKET_IGMP_MEMBERSHIP_QUERY = 0x11,
		PACKET_IGMP_MEMBERSHIP_REPORT = 0x16,
		PACKET_IGMP_LEAVE_GROUP = 0x17
	};

protected:
	CAddress		group;
	EPacketIgmpType	type;
	__time			maxResponse;

public:
	CPacketIgmp(
		CAddress		group,
		EPacketIgmpType	type,
		__time			maxResponse = 0
		);
	virtual ~CPacketIgmp() { }

	virtual inline EPacketType	Type() { return PACKET_TYPE_IGMP; }
	virtual CPacket*			Copy();

	inline CAddress				Group() { return this->group; }
	inline EPacketIgmpType		IgmpType() { return this->type; }
	inline __time				MaxResponse() { return this->maxResponse; }
};
