#pragma once

#include "Packet.h"
#include "Address.h"

#define PACKET_IP_HEADER	160

class CPacketIp : public CPacket
{
protected:
	CAddress	src;
	CAddress	dst;
	__byte		ttl;

public:
	CPacketIp(
		CAddress	src,
		CAddress	dst,
		__byte		ttl,
		CPacket*	payload
		);
	virtual ~CPacketIp() { }

	inline CAddress				Src() { return this->src; }
	inline CAddress				Dst() { return this->dst; }
	inline __byte				Ttl() { return this->ttl; }
	
	inline void					DecTtl() { this->ttl--; }

	virtual inline EPacketType	Type() { return PACKET_TYPE_IP; }
	virtual CPacket*			Copy();
};
