#include "Headers.h"
#include "Rand.h"

__uint32 CRand::Init()
{
#if !defined(DETRAND)
	__uint32 seed = (__uint32)time(NULL);
	srand(seed);
#endif
	return 0;
}

double CRand::Generate()
{
#if !defined(DETRAND) && defined(_WINDOWS)
	__uint32 rvalue;
	rand_s(&rvalue);
	return ((double)rvalue) / UINT_MAX;
#else
#if RAND_MAX == 0x7FFF
	return ((double)rand()*rand()) / ((double)RAND_MAX*RAND_MAX);
#else
	return ((double)rand()) / ((double)RAND_MAX);
#endif
#endif
}

__uint32 CRand::Generate(__uint32 max)
{
#if !defined(DETRAND) && defined(_WINDOWS)
	__uint32 rvalue;
	rand_s(&rvalue);
	return (__uint32)(max * (((double)rvalue) / UINT_MAX));
#else
#if RAND_MAX == 0x7FFF
	return (__uint32)(max * ((double)rand()*rand() / (RAND_MAX*RAND_MAX)));
#else
	return (__uint32)(max * ((double)rand() / RAND_MAX));
#endif
#endif
}

__uint32 CRand::GenerateUInt32()
{
#if !defined(DETRAND) && defined(_WINDOWS)
	__uint32 rnd;
	rand_s(&rnd);
	return rnd;
#else
#if RAND_MAX == 0x7FFF
	return (((__uint32)rand()) << 17) | (((__uint32)rand()) << 2) | (((__uint32)rand()) & 0x3);
#else
	return (((__uint32)rand()) << 1) | (((__uint32)rand())  & 0x1);
#endif
#endif
}