#pragma once

#include "Node.h"
#include "LayerIpRoute.h"
#include "LayerPimSm.h"

class CRouter : public CNode
{
protected:
	// Layers
	CLayerIpRoute*	layerIpRoute;
	CLayerIgmp*		layerIgmp;
	CLayerPimSm*	layerPimSm;

public:
	CRouter(
		__uint32		id,
		CSimHandler*	sim,
		CAddress		address,
		__uint32		numLinks,
		CRoute*			route,
		CInfo*			info,
		CAddress*		rp
		);
	virtual ~CRouter();

	virtual void	Finalize();

	inline double	StatMcastEntriesIgmp() { return this->layerIgmp->StatEntries(); }
	inline double	StatMcastEntriesPimSm() { return this->layerPimSm->StatEntries(); }
};
