#include "Headers.h"
#include "Shuffle.h"
#include "Rand.h"

CShuffle::CShuffle(
	__uint32	count
	)
{
	assert(count);

	this->count = count;

	this->mapping = new __uint32[this->count];
	assert(this->mapping);

	for(__uint32 index = 0; index < this->count; index++)
		this->mapping[index] = index;

	this->Shuffle();
}

CShuffle::~CShuffle()
{
	delete[] this->mapping;
}

void CShuffle::Shuffle()
{
	/*
	 * Portions of this code are based on: http://benpfaff.org/writings/clc/shuffle.html (last updated 04 Apr 2004 16:19)
	 * Copyright  2004 Ben Pfaff.
	 */

	__uint32 i2;
	__uint32 tmp;
	
	for(__uint32 i1 = 0; i1 < this->count - 1; i1++)
	{
		i2 = i1 + CRand::Generate(this->count - i1);
		assert(i2 < this->count);

		tmp = this->mapping[i2];
		this->mapping[i2] = this->mapping[i1];
		this->mapping[i1] = tmp;
	}
}
