#pragma once

#include "SimHandler.h"
#include "SimModel.h"
#include "SimEventList.h"
#include "SimCalls.h"

class CSim : public CSimHandler
{
private:
	char*			name;
	CSimModel*		model;
	CSimEventList*	events;
	CSimCalls*		calls;
	__time			time;

public:
	CSim(char* name, CSimModel* model);
	~CSim();

	__uint32		Run(time_t& duration);

	virtual __time	Time();
	virtual void	ScheduleEventNow(CSimEvent* evt);
	virtual void	ScheduleEventAt(__time time, CSimEvent* evt);
	virtual void	ScheduleEventAfter(__time delay, CSimEvent* evt);
	virtual void	CancelEvent(__time time, CSimEvent* evt);
	virtual void	operator()(ICall* call);
};
