#include "Headers.h"
#include "StreamBootPush.h"

void CStreamBootPush::Register(CAddress host, CAddress source)
{
	this->hosts.insert(pair<CAddress, CStreamBootEntry>(host, CStreamBootEntry(source)));
}

void CStreamBootPush::Deregister(CAddress host)
{
	this->hosts.erase(host);
}

bool CStreamBootPush::IsDependent(CAddress host, CAddress parent)
{
	// For all ancestors from the parent to the root
	for(CAddress ancestor = parent; ancestor != this->root;)
	{
		// If the host is an ancestor of the parent, return true
		if(ancestor == host) return true;

		// Else, get the entry of the ancestor
		List::iterator entry = this->hosts.find(ancestor);

		// If there is not entry for the ancestor (the ancestor is orphan), return true
		if(this->hosts.end() == entry) return true;

		// Else, move the the source of the ancestor
		ancestor = entry->second.Source();
	}
	return false;
}