#pragma once

#include "Address.h"
#include "StreamBootPushEntry.h"

class CStreamBootPushMulti
{
public:
	typedef map<CAddress, CStreamBootEntry> List;

private:
	__uint32	layers;
	CAddress	root;
	List*		hosts;

public:
	CStreamBootPushMulti(__uint32 layers, CAddress root);
	virtual ~CStreamBootPushMulti();

	void			Register(__uint32 layer, CAddress host, CAddress source);
	void			Deregister(__uint32 layer, CAddress host);

	bool			IsDependent(__uint32 layer, CAddress host, CAddress parent);

	inline List*	Fetch(__uint32 layer) { assert(layer < this->layers); return &this->hosts[layer]; }
};