#pragma once

#include "StreamFrame.h"

class CStreamBufferLayer
{
private:
	__uint32		size;
	__uint32		sizeHistory;
	__uint32		sizePlay;

	__uint32		ptrFirst;
	__uint32		ptrLast;

	__uint32		currentIndex;

	__uint32		count;
	__uint32		numHistory;
	__uint32		numPlay;

	CStreamFrame*	buffer;
	bool*			bitmap;
	bool*			coder;

public:
	CStreamBufferLayer(
		__uint32	size,
		__uint32	sizeHistory
		);
	~CStreamBufferLayer();

	void					Reset(__uint32 index);
	bool					Add(CStreamFrame frame, __uint32 layerIndex);

	inline __uint32			Size() { return this->size; }
	inline __uint32			SizePlay() { return this->sizePlay; }
	inline __uint32			SizeHistory() { return this->sizeHistory; }
	
	inline __uint32			Count() { return this->count; }
	inline __uint32			NumPlay() { return this->numPlay; }
	inline __uint32			NumHistory() { return this->numHistory; }

	void					Shift();

	bool					Has(__uint32 index);
	inline bool				HasCurrentIndex() { return this->bitmap[this->ptrFirst]; }

	inline __uint32			CurrentIndex() { return this->currentIndex; }
	inline CStreamFrame*	CurrentFrame() { return &this->buffer[this->ptrFirst]; }
	CStreamFrame*			Frame(__uint32 index);

	bool					IsCurrentDecodable();
	bool					IsDecodable(__uint32 index);
	void					SetCurrentDecodable();
	void					SetDecodable(__uint32 index);
	inline bool				IsCurrentIndependent() { return this->bitmap[this->ptrFirst] && (this->buffer[this->ptrFirst].AnchorP() == 0) && (this->buffer[this->ptrFirst].AnchorB() == 0); }
};