#pragma once

#include "StreamBufferSegment.h"

class CStreamBufferPull
{
private:
	__uint32				size;
	__uint32				sizeSegment;
	__uint32				sizeHistory;
	__uint32				sizePlay;
	
	__uint32				ptrFirst;
	__uint32				ptrLast;

	__uint32				currentIndex;
	__uint32				currentSegment;

	CStreamBufferSegment**	buffer;

public:
	CStreamBufferPull(
		__uint32	size,
		__uint32	sizeSegment,
		__uint32	sizeHistory
		);
	virtual ~CStreamBufferPull();

	void	Reset(__uint32 frame);
	bool	Add(CStreamSegmentFrame frame);
	void	Shift();

	inline bool					HasCurrentIndex() { return this->buffer[this->ptrFirst]->Has(this->currentIndex); }
	inline __uint32				CurrentIndex() { return this->currentIndex; }
	inline __uint32				CurrentSegment() { return this->currentSegment; }
	inline CStreamSegmentFrame*	CurrentFrame() { return this->buffer[this->ptrFirst]->Frame(this->currentIndex); }

	bool						IsCurrentDecodable();
	inline bool					IsCurrentComplete() { return this->buffer[this->ptrFirst]->IsComplete(); }
	bool						IsDecodable(__uint32 frame);
	bool						IsComplete(__uint32 segment);

	void						Log();
};