#pragma once

#include "StreamSegment.h"

class CStreamBufferSegment
{
private:
	__uint32			size;
	__uint32			sizeHistory;
	__uint32			sizePlay;
	__uint32			sizeSegment;

	__uint32			ptrFirst;
	__uint32			ptrLast;

	__uint32			currentIndexSegment;
	__uint32			currentIndexFrame;

	__uint32			stream;

	CStreamSegment**	buffer;

public:
	CStreamBufferSegment(
		__uint32	size,
		__uint32	sizeHistory,
		__uint32	sizeSegment
		);
	virtual ~CStreamBufferSegment();

	void			Reset(__uint32 stream, __uint32 indexSegment);
	bool			Add(CStreamFrame frame);

	inline __uint32	Size() { return this->size; }
	inline __uint32	SizePlay() { return this->sizePlay; }
	inline __uint32	SizeHistory() { return this->sizeHistory; }

	inline __uint32	Stream() { return this->stream; }

	void			ShiftFrame();
	void			ShiftSegment();

	inline __uint32	CurrentIndexSegment() { return this->currentIndexSegment; }
	inline __uint32	CurrentIndexFrame() { return this->currentIndexSegment * this->sizeSegment + this->currentIndexFrame; }

	bool			HasSegment(__uint32 index);
	inline bool		HasCurrentSegment() { return this->buffer[this->ptrFirst] != NULL; }

	bool			IsSegmentReceiving(__uint32 index);
	bool			IsSegmentComplete(__uint32 index);

	void			SegmentReceiving(__uint32 index, bool receiving);

	bool			HasFrame(__uint32 index);
	bool			HasCurrentFrame();

	bool			IsCurrentFrameDecodable();
	bool			IsFrameDecodable(__uint32 index);

	CStreamSegment*	GetSegment(__uint32 index);

	CStreamFrame	CurrentFrame();
};
