#pragma once

#include "Stream.h"
#include "Channel.h"
#include "Address.h"
#include "StreamFrame.h"
#include "StreamMessage.h"
#include "PacketStream.h"

class CStreamClient : public CStream
{
public:
	CStreamClient(CSimHandler* sim) : CStream(sim) { }
	virtual ~CStreamClient() { }

	virtual void			Start(CChannel*	channel) = 0;
	virtual void			Stop() = 0;

	virtual void			Recv(CAddress srcAddress, CAddress dstAddress, __uint16 srcPort, __uint16 dstPort, CPacket* packet) = 0;
	
	virtual __uint32		StatRecvFrames() = 0;
	virtual __uint32		StatDiscardedFrames() = 0;
	virtual __uint32		StatPlayFrames() = 0;
	virtual __uint32*		StatSuccessFrames() = 0;
	virtual __uint32*		StatFailFrames() = 0;
	
	virtual __time			StatTimeClientStart() = 0;
	virtual __time			StatTimeRecvStart() = 0;
	virtual __time			StatTimePlayStart() = 0;
	virtual __time			StatTimeFinish() = 0;
	virtual __time			StatTimeWait() = 0;

	virtual __uint32		StatPlayFirstFrame() = 0;
	virtual __uint32		StatPlayLastFrame() = 0;

	virtual __time			StatSyncDelay() = 0;
};