#include "Headers.h"
#include "StreamDecoderFrame.h"
#include "PacketStreamFrame.h"

CStreamDecoderFrame::CStreamDecoderFrame(
	IDelegate2<void, CAddress, CStreamFrame>*	delegateRecv
	) : CStreamDecoder()
{
	assert(delegateRecv);

	this->delegateRecv = delegateRecv;
}

CStreamDecoderFrame::CStreamDecoderFrame(
	__uint32									stream,
	IDelegate2<void, CAddress, CStreamFrame>*	delegateRecv
	) : CStreamDecoder(stream)
{
	assert(delegateRecv);

	this->delegateRecv = delegateRecv;
}

CStreamDecoder::EResult CStreamDecoderFrame::Decode(CAddress address, CPacketStream* packet)
{
	assert(packet);

	// Verify the packet is a frame packet
	if(packet->StreamType() != CPacketStream::STREAM_TYPE_FRAME) return FAIL_PACKET_TYPE;

	// Validate the packet
	if(packet->Stream() != this->stream) return FAIL_STREAM;

	// Receive the packet through the delegate
	(*this->delegateRecv)(address, type_cast<CPacketStreamFrame*>(packet)->Frame());

	return SUCCESS;
}
