#pragma once

#include "Packet.h"

#define BOOT_MAX_HOSTS	10
#define BOOT_MAX_LAYERS	10

class CStreamMessage : public CPacket
{
public:
	enum EMessageType
	{
		// Push
		STREAM_MESSAGE_BOOT_PUSH_REGISTER = 0,
		STREAM_MESSAGE_BOOT_PUSH_DEREGISTER = 1,
		STREAM_MESSAGE_BOOT_PUSH_REQUEST = 2,
		STREAM_MESSAGE_BOOT_PUSH_RESPONSE = 3,
		STREAM_MESSAGE_PUSH_JOIN = 4,
		STREAM_MESSAGE_PUSH_LEAVE = 5,
		STREAM_MESSAGE_PUSH_CLOSE = 6,

		// Push
		STREAM_MESSAGE_BOOT_PUSH_MULTI_REGISTER = 10,
		STREAM_MESSAGE_BOOT_PUSH_MULTI_DEREGISTER = 11,
		STREAM_MESSAGE_BOOT_PUSH_MULTI_REQUEST = 12,
		STREAM_MESSAGE_BOOT_PUSH_MULTI_RESPONSE = 13,
		STREAM_MESSAGE_PUSH_MULTI_JOIN = 14,
		STREAM_MESSAGE_PUSH_MULTI_LEAVE = 15,
		STREAM_MESSAGE_PUSH_MULTI_CLOSE = 16,

		// Pull
		STREAM_MESSAGE_BOOT_PULL_REGISTER = 20,
		STREAM_MESSAGE_BOOT_PULL_DEREGISTER = 21,
		STREAM_MESSAGE_BOOT_PULL_REQUEST = 22,
		STREAM_MESSAGE_BOOT_PULL_RESPONSE = 23,
		STREAM_MESSAGE_PULL_BITMAP_REQUEST = 24,
		STREAM_MESSAGE_PULL_BITMAP_RESPONSE = 25,
		STREAM_MESSAGE_PULL_SEGMENT_REQUEST = 26,
		STREAM_MESSAGE_PULL_SEGMENT_RESPONSE = 27
	};

protected:
	EMessageType	messageType;
	__uint32		stream;

public:
	CStreamMessage(
		EMessageType	messageType,
		__uint32		size,
		__uint32		stream
		);
	virtual ~CStreamMessage() { }

	inline EMessageType		MessageType() { return this->messageType; }
	inline __uint32			Stream() { return this->stream; }

	virtual EPacketType		Type() { return PACKET_TYPE_MESSAGE; }
};