#include "Headers.h"
#include "StreamMessageBootPullResponse.h"

CStreamMessageBootPullResponse::CStreamMessageBootPullResponse(
	__uint32	stream,
	__uint32	count
	) : CStreamMessage(CStreamMessage::STREAM_MESSAGE_BOOT_PULL_RESPONSE, (count+1) * 32, stream)
{
	assert(count < BOOT_MAX_HOSTS);
	this->count = count;
}

CStreamMessageBootPullResponse::~CStreamMessageBootPullResponse()
{
}

CPacket* CStreamMessageBootPullResponse::Copy()
{
	CStreamMessageBootPullResponse* packet = new CStreamMessageBootPullResponse(this->stream, this->count);
	assert_mem(packet);

	for(__uint32 host = 0; host < this->count; host++)
		packet->hosts[host] = this->hosts[host];

	return packet;
}