#include "Headers.h"
#include "StreamMessageBootPushMultiRequest.h"

CStreamMessageBootPushMultiRequest::CStreamMessageBootPushMultiRequest(
	__uint32	stream,
	__uint32	count
	) : CStreamMessage(CStreamMessage::STREAM_MESSAGE_BOOT_PUSH_MULTI_REQUEST, 64, stream)
{
	this->type = STREAM;
	this->layer = 0;
	this->count = count;
}

CStreamMessageBootPushMultiRequest::CStreamMessageBootPushMultiRequest(
	__uint32	stream,
	__uint32	layer,
	__uint32	count
	) : CStreamMessage(CStreamMessage::STREAM_MESSAGE_BOOT_PUSH_MULTI_REQUEST, 96, stream)
{
	this->type = LAYER;
	this->layer = layer;
	this->count = count;
}

CPacket* CStreamMessageBootPushMultiRequest::Copy()
{
	CPacket* packet;
	switch(this->type)
	{
	case STREAM: packet = new CStreamMessageBootPushMultiRequest(
						 this->stream,
						 this->count
						 );
		break;
	case LAYER: packet = new CStreamMessageBootPushMultiRequest(
						this->stream,
						this->layer,
						this->count
						);
		break;
	};

	assert_mem(packet);
	return packet;
}
