#pragma once

#include "StreamMessage.h"
#include "Address.h"

class CStreamMessageBootPushMultiResponse : public CStreamMessage
{
public:
	enum EResponseType
	{
		STREAM = 0,
		LAYER = 1
	};

private:
	EResponseType	type;
	__uint32		layer;
	__uint32		layers;

	__uint32		count[BOOT_MAX_LAYERS];
	CAddress		hosts[BOOT_MAX_LAYERS][BOOT_MAX_HOSTS];

public:
	CStreamMessageBootPushMultiResponse(
		__uint32	stream,
		__uint32	layers
		);
	CStreamMessageBootPushMultiResponse(
		__uint32	stream,
		__uint32	layer,
		__uint32	count
		);
	virtual ~CStreamMessageBootPushMultiResponse() { }

	inline EResponseType	ResponseType() { return this->type; }
	inline __uint32			Layer() { return this->layer; }

	inline __uint32			Count(__uint32 layer) { assert(layer < this->layers); return this->count[layer]; }
	void					Set(__uint32 layer, __uint32 count);
	inline CAddress&		Host(__uint32 layer, __uint32 index) { assert(layer < this->layers); assert(index < this->count[layer]); return this->hosts[layer][index]; }

	virtual CPacket*		Copy();
};