#include "Headers.h"
#include "StreamMessagePullBitmapResponse.h"

CStreamMessagePullBitmapResponse::CStreamMessagePullBitmapResponse(
	__uint32	stream,
	__uint32	first,
	__uint8		count,
	__uint64	bitmap,
	__bitrate	bw,
	__bitrate	bwUtil,
	EConnection	connection,
	__uint32	connectionId,
	__uint32	connectionIdEntry,
	EResponse	response,
	EPreference	pref
	) : CStreamMessagePull(STREAM_MESSAGE_PULL_BITMAP_RESPONSE, 240, stream, connection, connectionId, connectionIdEntry)
{
	assert(count <= 64);

	this->first = first;
	this->count = count;
	this->bitmap = bitmap;
	this->bw = bw;
	this->bwUtil = bwUtil;
	this->response = response;
	this->pref = pref;
}

CStreamMessagePullBitmapResponse::~CStreamMessagePullBitmapResponse()
{
}

CPacket* CStreamMessagePullBitmapResponse::Copy()
{
	CStreamMessagePullBitmapResponse* packet = new CStreamMessagePullBitmapResponse(
		this->stream,
		this->first,
		this->count,
		this->bitmap,
		this->bw,
		this->bwUtil,
		this->connection,
		this->connectionId,
		this->connectionIdEntry,
		this->response,
		this->pref
		);
	assert_mem(packet);

	return packet;
}
