#pragma once

#include "StreamMessagePull.h"

class CStreamMessagePullBitmapResponse : public CStreamMessagePull
{
public:
	enum EResponse
	{
		SUCCESS = 0,
		FAIL = 1
	};
	enum EPreference
	{
		PREF_HIGH = 0,
		PREF_LOW = 1
	};

private:
	__uint32	first;
	__uint8		count;
	__uint64	bitmap;
	__bitrate	bw;
	__bitrate	bwUtil;
	
	EResponse	response;
	EPreference	pref;

public:
	CStreamMessagePullBitmapResponse(
		__uint32	stream,
		__uint32	first,
		__uint8		count,
		__uint64	bitmap,
		__bitrate	bw,
		__bitrate	bwUtil,
		EConnection	connection,
		__uint32	connectionId,
		__uint32	connectionIdEntry,
		EResponse	response,
		EPreference	pref
		);
	virtual ~CStreamMessagePullBitmapResponse();

	virtual CPacket*	Copy();
	
	inline __uint32		First() { return this->first; }
	inline __uint8		Count() { return this->count; }
	inline __uint64		Bitmap() { return this->bitmap; }
	inline __bitrate	Bw() { return this->bw; }
	inline __bitrate	BwUtil() { return this->bwUtil; }

	inline EResponse	Response() { return this->response; }
	inline EPreference	Preference() { return this->pref; }
};