#include "Headers.h"
#include "StreamMessagePullSegmentRequest.h"

CStreamMessagePullSegmentRequest::CStreamMessagePullSegmentRequest(
	__uint32	stream,
	__uint32	srcId,
	__uint32	srcIdEntry,
	__uint32	dstId,
	__uint32	dstIdEntry,
	__uint32	first,
	__uint8		count,
	__uint64	bitmap
	) : CStreamMessage(STREAM_MESSAGE_PULL_SEGMENT_REQUEST, 232, stream)
{
	assert(count <= 64);

	this->srcId = srcId;
	this->srcIdEntry = srcIdEntry;
	this->dstId = dstId;
	this->dstIdEntry = dstIdEntry;

	this->first = first;
	this->count = count;
	this->bitmap = bitmap;
}

CPacket* CStreamMessagePullSegmentRequest::Copy()
{
	CStreamMessagePullSegmentRequest* packet = new CStreamMessagePullSegmentRequest(
		this->stream,
		this->srcId,
		this->srcIdEntry,
		this->dstId,
		this->dstIdEntry,
		this->first,
		this->count,
		this->bitmap
		);
	assert_mem(packet);

	return packet;
}
