#pragma once

#include "StreamMessagePull.h"

class CStreamMessagePullSegmentRequest : public CStreamMessage
{
private:
	__uint32	srcId;
	__uint32	srcIdEntry;
	__uint32	dstId;
	__uint32	dstIdEntry;

	__uint32	first;
	__uint8		count;	// bitmap size
	__uint64	bitmap;

public:
	CStreamMessagePullSegmentRequest(
		__uint32	stream,
		__uint32	srcId,
		__uint32	srcIdEntry,
		__uint32	dstId,
		__uint32	dstIdEntry,
		__uint32	first,
		__uint8		count,
		__uint64	bitmap
		);
	virtual ~CStreamMessagePullSegmentRequest() { }

	inline __uint32		SrcId() { return this->srcId; }
	inline __uint32		SrcIdEntry() { return this->srcIdEntry; }
	inline __uint32		DstId() { return this->dstId; }
	inline __uint32		DstIdEntry() { return this->dstIdEntry; }

	inline __uint32		First() { return this->first; }
	inline __uint8		Count() { return this->count; }
	inline __uint64		Bitmap() { return this->bitmap; }

	virtual CPacket*	Copy();
};