#pragma once

#include "ConnectionTag.h"
#include "ConnectionSender.h"
#include "Timer.h"

class CStreamPullReceiver : public CConnectionTag
{
public:
	typedef map<__uint32, CStreamPullReceiver*>	TReceiverList;

private:
	// Input
	CConnectionSender*				connection;
	__time							interval;

	// Buffer
	queue<CStreamFrame>				buffer;

	// Timer
	CTimer<CStreamPullReceiver>*	timer;

	// List
	__uint32						id;
	TReceiverList*					list;

public:
	CStreamPullReceiver(
		CSimHandler*		sim,
		CConnectionSender*	connection,
		__time				interval,
		__uint32			id,
		TReceiverList*		list
		);
	virtual ~CStreamPullReceiver();

	inline CConnectionSender*	Connection() { return this->connection; }

	void						Send(CStreamFrame frame);

	void						List(TReceiverList* list);
	inline TReceiverList*		List() { return this->list; }

private:
	void						Timer(CTimerInfo* info);
};