#include "Headers.h"
#include "StreamSegment.h"

CStreamSegment::CStreamSegment(
	__uint32	size
	)
{
	this->stream = 0xFFFFFFFF;
	this->index = 0xFFFFFFFF;
	this->size = size;
	this->completed = 0;

	// Allocate frames
	this->frames = new CStreamFrame[this->size];
	assert_mem(this->frames);
}

CStreamSegment::~CStreamSegment()
{
	// If the frames do not point to the frame for single frame segment, release the memory
	delete[] this->frames;
}

void CStreamSegment::Add(CStreamFrame frame)
{
	assert(frame.Stream() == this->stream);
	assert(frame.SegmentIndex() < this->size);
	assert(frame.SegmentSize() == this->size);

	this->completed += this->frames[frame.SegmentIndex()].Valid()?0:1;

	this->frames[frame.SegmentIndex()] = frame;
}

void CStreamSegment::Reset(__uint32 stream, __uint32 index)
{
	// Reset segment to the specified stream and index
	this->stream = stream;
	this->index = index;
	this->completed = 0;
	this->receiving = false;

	// Clear the frames
	for(__uint32 idx = 0; idx < this->size; idx++)
		this->frames[idx] = CStreamFrame();
}