#pragma once

#include "StreamFrame.h"

class CStreamSegment
{
private:
	__uint32		stream;
	__uint32		index;
	__uint32		size;
	__uint32		completed;
	bool			receiving;
	
	CStreamFrame*	frames;

public:
	CStreamSegment(__uint32 size);
	~CStreamSegment();

	inline __uint32		Stream() { return this->stream; }
	inline __uint32		Index() { return this->index; }
	inline __uint32		Size() { return this->size; }

	inline bool			IsComplete() { return this->completed == this->size; }
	inline void			Receiving(bool receiving) { this->receiving = receiving; }
	inline bool			IsReceiving() { return this->receiving; }
	
	void				Add(CStreamFrame frame);
	void				Reset(__uint32 stream, __uint32 index);

	inline CStreamFrame	operator [](__uint32 index) { return this->frames[index]; }
};