#pragma once

#include "StreamServer.h"
#include "Address.h"
#include "Timer.h"
#include "StreamEncoderFrame.h"
#include "PacketIp.h"
#include "PacketUdp.h"
#include "PacketStream.h"

class CStreamServerPushMcast : public CStreamServer
{
private:
	// Global
	CTimer<CStreamServerPushMcast>*	timer;
	__uint32						entry;

	// Stream
	CStreamSource*					source;
	__time							scheduleTime;
	__uint32						scheduleFrame;
	__uint32						scheduleRate;
	__uint32						deltaFrame;

	// Coders
	CStreamEncoderFrame*			encoder;

	// Delegates
	IDelegate2<void, CAddress, CPacketStream*>*
									delegateSendStream;

	IDelegate2<void, CAddress, __uint32>*
									delegateIgmpJoin;
	IDelegate1<void, CAddress>*		delegateIgmpLeave;

public:
	CStreamServerPushMcast(
		CSimHandler*									sim,
		CStreamSource*									source,
		IDelegate2<void, CAddress, CPacketStream*>*		delegateSendStream,
		IDelegate2<void, CAddress, __uint32>*			delegateIgmpJoin,
		IDelegate1<void, CAddress>*						delegateIgmpLeave,
		__uint32										entry
		);
	virtual ~CStreamServerPushMcast();

	// Control
	void			Start();
	void			Stop();

	// Finalizer
	virtual void	Finalize();

private:
	void			Timer(CTimerInfo* info);
};