#include "Headers.h"
#include "StreamSource.h"

CStreamSource::CStreamSource(CChannel* channel)
{
	assert(channel);
	this->channel = channel;
}

void CStreamSource::Synchronize(__time currentTime, __time& scheduleTime, __uint32& frame)
{
	// Calculate the next sync time and frame based on the current time
	frame = (__uint32)ceil(currentTime * this->channel->Fps());
	scheduleTime = frame / this->channel->Fps();
}

__uint32 CStreamSource::Synchronize(__time time)
{
	return (__uint32)(time * this->channel->Fps());
}

__time CStreamSource::FrameTime(__uint32 index)
{
	return ((double)index) / this->channel->Fps();
}