#pragma once

#include "StreamSource.h"
#include "Codes.h"

class CStreamSourceMpegFrameTemplate
{
public:
	EFrameType	type;
	__uint32	size;
	char		anchorP;
	char		anchorB;

	CStreamSourceMpegFrameTemplate() { }
	CStreamSourceMpegFrameTemplate(
		EFrameType	type,
		__uint32	size,
		char		anchorP,
		char		anchorB
		);
	~CStreamSourceMpegFrameTemplate() { }
};

class CStreamSourceMpeg : public CStreamSource
{
protected:
	__byte	gopDistanceItoI;
	__byte	gopDistanceItoP;

	CStreamSourceMpegFrameTemplate*	gopTemplate;

	__byte	segmentSize;

public:
	CStreamSourceMpeg(
		CChannel*	channel,
		__byte		gopDistanceItoI,
		__byte		gopDistanceItoP,
		__byte		segmentSize = 1
		);
	virtual ~CStreamSourceMpeg();

	virtual CStreamFrame		Fetch(__uint32 index);
	virtual inline EFrameType	FrameType(__uint32 index) {	return this->gopTemplate[index % this->gopDistanceItoI].type; }
};