#include "Headers.h"
#include "TopoBriteNode.h"

CTopoBriteNode::CTopoBriteNode(
	__uint32	id,
	__uint32	xpos,
	__uint32	ypos,
	__uint32	degree
	)
{
	this->id = id;
	this->xpos = xpos;
	this->ypos = ypos;
	this->degree = degree;

	this->edges = new __uint32[this->degree];
	assert(this->edges);

	for(__uint32 index = 0; index < this->degree; index++) this->edges[index] = 0xFFFFFFFF;
	this->edgeSet = 0;
}

CTopoBriteNode::~CTopoBriteNode()
{
	delete[] this->edges;
}

void CTopoBriteNode::SetEdge(__uint32 edge)
{
	assert(this->edgeSet < this->degree);
	this->edges[this->edgeSet++] = edge;
}
