#pragma once

#include "TopoRoute.h"
#include "TopoBriteNode.h"
#include "TopoBriteEdge.h"

class CTopoBriteRoute : public CTopoRoute
{
private:
	__uint32		numNodes;
	__uint32		numEdges;

	CTopoBriteEdge**	edges;
	CTopoBriteNode**	nodes;

	int*				routeEdge;
	int*				routeNode;
	CTopoBriteEdge**	graph;

	__uint32*		distance;
	
public:
	CTopoBriteRoute(
		__uint32		numNodes,
		__uint32		numEdges,
		CTopoBriteNode**	nodes,
		CTopoBriteEdge**	edges
		);
	~CTopoBriteRoute();

	__uint32	NextEdge(__uint32 node, __uint32 dst);
	__uint32	NextNode(__uint32 node, __uint32 dst);
	__uint32	Distance(__uint32 src, __uint32 dst);

protected:
	void			ShortestPath(__uint32 node);
	void			ShortestPathInit(__uint32 node, double* dist, bool* res);
};
