#include "Headers.h"
#include "WorkloadFlat2Cat.h"
#include "Rand.h"

CWorkloadFlat2Cat::CWorkloadFlat2Cat(
	__uint32	numChannels,
	__uint32	numPopular,
	double			probPopular
	) : CWorkload(numChannels)
{
	this->numPopular = numPopular;
	this->probPopular = (__uint32)(0xFFFFFFFF * probPopular);

}

void CWorkloadFlat2Cat::GenerateUptime(__uint32 &newCh, __time &duration)
{
	__uint32 pr = CRand::GenerateUInt32();
	__uint32 ch = CRand::GenerateUInt32();
	__uint32 dindex;

//#if defined(DETRAND) && defined(_WINDOWS)
//	rand_s(&pr);
//	rand_s(&ch);
//#else
//#if RAND_MAX == 0x7FFF
//	pr = (((__uint32)rand()) << 17) | (((__uint32)rand()) << 2) | (((__uint32)rand()) & 0x3);
//	ch = (((__uint32)rand()) << 17) | (((__uint32)rand()) << 2) | (((__uint32)rand()) & 0x3);
//#else
//	pr = (((__uint32)rand()) < 1) | (((__uint32)rand())  & 0x1);
//	ch = (((__uint32)rand()) < 1) | (((__uint32)rand())  & 0x1);
//#endif
//#endif

	dindex = channelCdfIndex[pr >> 15];
	duration = channelCdf[dindex][0] + CRand::Generate();

	pr = CRand::GenerateUInt32();
//#if defined(DETRAND) && defined(_WINDOWS)
//	rand_s(&pr);
//#else
//#if RAND_MAX == 0x7FFF
//	pr = (((__uint32)rand()) << 17) | (((__uint32)rand()) << 2) | (((__uint32)rand()) & 0x3);
//#else
//	pr = (((__uint32)rand()) < 1) | (((__uint32)rand())  & 0x1);
//#endif
//#endif

	// Generate new channel (a random channel)
	if(pr < this->probPopular)
		newCh = (__uint32)(((__uint64)ch)*this->numPopular/0x100000000LL);
	else
		newCh = this->numPopular + (__uint32)(((__uint64)ch)*(this->numChannels-this->numPopular)/0x100000000LL);

	assert(newCh < this->numChannels);
}

void CWorkloadFlat2Cat::GenerateUptime(__uint32 oldCh, __time oldDuration, __uint32 &newCh, __time &duration)
{
	__uint32 pr = CRand::GenerateUInt32();
	__uint32 prb = CRand::GenerateUInt32();
	__uint32 ch = CRand::GenerateUInt32();
	__uint32 dindex;

//#ifndef DETRAND
//	rand_s(&pr);
//	rand_s(&ch);
//	rand_s(&prb);
//#else
//	pr = (((__uint32)rand()) << 17) | (((__uint32)rand()) << 2) | (((__uint32)rand()) & 0x3);
//	ch = (((__uint32)rand()) << 17) | (((__uint32)rand()) << 2) | (((__uint32)rand()) & 0x3);
//	prb = (((__uint32)rand()) << 17) | (((__uint32)rand()) << 2) | (((__uint32)rand()) & 0x3);
//#endif

	dindex = channelCdfIndex[pr >> 15];
	duration = channelCdf[dindex][0] + CRand::Generate();

	pr = CRand::GenerateUInt32();
//#ifndef DETRAND
//	rand_s(&pr);
//#else
//	pr = (((__uint32)rand()) << 17) | (((__uint32)rand()) << 2) | (((__uint32)rand()) & 0x3);
//#endif

	// Switch
	if(pr < this->probPopular)
	{
		// Switch to popular channel
		if(oldCh < this->numPopular)
		{
			newCh = (__uint32)(((__uint64)ch)*(this->numPopular-1)/0x100000000LL);
			if(newCh >= oldCh) newCh++;
		}
		else
			newCh = (__uint32)(((__uint64)ch)*this->numPopular/0x100000000LL);
	}
	else
	{
		// Switch to unpopular channel
		if(oldCh < this->numPopular)
			newCh = this->numPopular + (__uint32)(((__uint64)ch)*(this->numChannels-this->numPopular)/0x100000000LL);
		else
		{
			newCh = this->numPopular + (__uint32)(((__uint64)ch)*(this->numChannels-this->numPopular-1)/0x100000000LL);
			if(newCh >= oldCh) newCh++;
		}
	}

	assert(newCh != oldCh);
	assert(newCh < this->numChannels);
}
