#include "Headers.h"
#include "WorkloadFlat3Cat.h"
#include "Rand.h"

CWorkloadFlat3Cat::CWorkloadFlat3Cat(
	__uint32	numChannels,
	__uint32	numPopular1,
	__uint32	numPopular2,
	double			probPopular1,
	double			probPopular2
	) : CWorkload(numChannels)
{
	this->numPopular1 = numPopular1;
	this->numPopular2 = numPopular1+numPopular2;
	this->probPopular1 = (__uint32)(0xFFFFFFFF * probPopular1);
	this->probPopular2 = (__uint32)(0xFFFFFFFF * (probPopular1+probPopular2));
}

void CWorkloadFlat3Cat::GenerateUptime(__uint32 &newCh, __time &duration)
{
	__uint32 pr = CRand::GenerateUInt32();
	__uint32 ch = CRand::GenerateUInt32();
	__uint32 dindex;

//#ifndef DETRAND
//	rand_s(&pr);
//	rand_s(&ch);
//#else
//	pr = (((__uint32)rand()) << 17) | (((__uint32)rand()) << 2) | (((__uint32)rand()) & 0x3);
//	ch = (((__uint32)rand()) << 17) | (((__uint32)rand()) << 2) | (((__uint32)rand()) & 0x3);
//#endif

	dindex = channelCdfIndex[pr >> 15];
	duration = channelCdf[dindex][0];

	pr = CRand::GenerateUInt32();
//#ifndef DETRAND
//	rand_s(&pr);
//#else
//	pr = (((__uint32)rand()) << 17) | (((__uint32)rand()) << 2) | (((__uint32)rand()) & 0x3);
//#endif

	// Generate new channel (a random channel)
	if(pr < this->probPopular1)
		newCh = (__uint32)(((__uint64)ch)*this->numPopular1/0x100000000LL);
	else if(pr < this->probPopular2)
		newCh = this->numPopular1 + (__uint32)(((__uint64)ch)*(this->numPopular2-this->numPopular1)/0x100000000LL);
	else
		newCh = this->numPopular2 + (__uint32)(((__uint64)ch)*(this->numChannels-this->numPopular2)/0x100000000LL);

	assert(newCh < this->numChannels);
}

void CWorkloadFlat3Cat::GenerateUptime(__uint32 oldCh, __time oldDuration, __uint32 &newCh, __time &duration)
{
	__uint32 pr = CRand::GenerateUInt32();
	__uint32 prb = CRand::GenerateUInt32();
	__uint32 ch = CRand::GenerateUInt32();
	__uint32 dindex;

//#ifndef DETRAND
//	rand_s(&pr);
//	rand_s(&ch);
//	rand_s(&prb);
//#else
//	pr = (((__uint32)rand()) << 17) | (((__uint32)rand()) << 2) | (((__uint32)rand()) & 0x3);
//	ch = (((__uint32)rand()) << 17) | (((__uint32)rand()) << 2) | (((__uint32)rand()) & 0x3);
//	prb = (((__uint32)rand()) << 17) | (((__uint32)rand()) << 2) | (((__uint32)rand()) & 0x3);
//#endif

	dindex = channelCdfIndex[pr >> 15];
	duration = channelCdf[dindex][0];

	pr = CRand::GenerateUInt32();
//#ifndef DETRAND
//	rand_s(&pr);
//#else
//	pr = (((__uint32)rand()) << 17) | (((__uint32)rand()) << 2) | (((__uint32)rand()) & 0x3);
//#endif

	// Switch
	if(pr < this->probPopular1)
	{
		// Switch to category 1
		if(oldCh < this->numPopular1)
		{
			// Switch from category 1
			newCh = (__uint32)(((__uint64)ch)*(this->numPopular1-1)/0x100000000LL);
			if(newCh >= oldCh) newCh++;
		}
		else 
			// Switch from category 2 or 3
			newCh = (__uint32)(((__uint64)ch)*(this->numPopular1)/0x100000000LL);
	}
	else if(pr < this->probPopular2)
	{
		// Switch to category 2
		if(oldCh < this->numPopular1)
			// Switch from category 1
			newCh = this->numPopular1 + (__uint32)(((__uint64)ch)*(this->numPopular2-this->numPopular1)/0x100000000LL);
		else if(oldCh < this->numPopular2)
		{
			// Switch from category 2
			newCh = this->numPopular1 + (__uint32)(((__uint64)ch)*(this->numPopular2-this->numPopular1-1)/0x100000000LL);
			if(newCh >= oldCh) newCh++;
		}
		else
			// Switch from category 3
			newCh = this->numPopular1 + (__uint32)(((__uint64)ch)*(this->numPopular2-this->numPopular1)/0x100000000LL);
	}
	else
	{
		// Switch to category 3
		if(oldCh < this->numPopular2)
			// Switch from category 1 or 2
			newCh = this->numPopular2 + (__uint32)(((__uint64)ch)*(this->numChannels-this->numPopular2)/0x100000000LL);
		else
		{
			// Switch from category 3
			newCh = this->numPopular2 + (__uint32)(((__uint64)ch)*(this->numChannels-this->numPopular2-1)/0x100000000LL);
			if(newCh >= oldCh) newCh++;
		}
	}

	assert(newCh != oldCh);
	assert(newCh < this->numChannels);
}
