#pragma once

#include "Workload.h"

class CWorkloadSurf2Cat : public CWorkload
{
private:
	__uint32	numPopular;			// M
	__uint32	probSurfing;		// Q
	__uint32	probPopular;		// P
	__uint32	probSurfForward;	// a
	__uint32	probSurfCycle;		// b

	__time			surfThreshold;

public:
	CWorkloadSurf2Cat(
		__uint32	numChannels,
		__uint32	numPopular,
		double			probSurfing,
		double			probPopular,
		double			probSurfForward,
		double			probSurfCycle
		);
	~CWorkloadSurf2Cat() {}

	inline __time		SurfingThreshold() { return this->surfThreshold; }

	void				GenerateUptime(__uint32 &newCh, __time &duration);
	void				GenerateUptime(__uint32 oldCh, __time oldDuration, __uint32 &newCh, __time &duration);
	static __uint32	Cdf(__uint32 dindex);

protected:
	int		Find(double value);
	__time	Generate(__uint32 unit);
};